﻿Imports System.ComponentModel

Namespace ViewModel

	Public Class Movies
		Inherits BindingList(Of Movie)

#Region "Fields"

		Private _parent As MoviesViewModel

#End Region

#Region "Constructors"

		Public Sub New(parent As MoviesViewModel)

			AllowNew = True
			Parent = parent

			Dim movie As Movie

			movie = New Movie(Me)
			movie.ID = 133093
			movie.Name = "Matrix"
			movie.Rating = Parent.Ratings(3)

			Add(movie)

			movie = New Movie(Me)
			movie.ID = 120655
			movie.Name = "Dogma"
			movie.Rating = Parent.Ratings(4)

			Add(movie)

		End Sub

#End Region

#Region "Properties"

		Public Property Parent() As MoviesViewModel
			Get
				Return _parent
			End Get
			Set(value As MoviesViewModel)
				_parent = value
			End Set
		End Property

#End Region

#Region "BindingList Overrides"

		Protected Overrides Function AddNewCore() As Object
			Dim movie As Movie = DirectCast(MyBase.AddNewCore(), Movie)
			movie.Parent = Me
			Return movie
		End Function

#End Region

	End Class

	Public Class Movie
		Inherits ObservableObject

#Region "Fields"

		Protected _parent As Movies
		Protected _id As System.Nullable(Of Integer)
		Protected _name As String
		Protected _rating As Rating

#End Region

#Region "Constructors"

		Public Sub New()
		End Sub

		Public Sub New(parent As Movies)
			Me.New()
			parent = parent
		End Sub

#End Region

#Region "Data Properties"

		Public Property Parent() As Movies
			Get
				Return _parent
			End Get
			Set(value As Movies)
				_parent = value
			End Set
		End Property

		Public Property ID() As System.Nullable(Of Integer)
			Get
				Return _id
			End Get
			Set(value As System.Nullable(Of Integer))
				_id = value
				MyBase.RaisePropertyChangedEvent("ID")
			End Set
		End Property

		Public Property Name() As String
			Get
				Return _name
			End Get
			Set(value As String)
				_name = value
				MyBase.RaisePropertyChangedEvent("Name")
			End Set
		End Property

		Public Property Rating() As Rating
			Get
				Return _rating
			End Get
			Set(value As Rating)
				_rating = value
				MyBase.RaisePropertyChangedEvent("Rating")
			End Set
		End Property

#End Region

#Region "ToString Overrides"

		Public Overrides Function ToString() As String
			Return Name
		End Function

#End Region

	End Class

End Namespace