﻿Imports System.ComponentModel

Namespace ViewModel

	Public Class Ratings
		Inherits BindingList(Of Rating)

#Region "Fields"

		Private _parent As MoviesViewModel

#End Region

#Region "Constructors"

		Public Sub New(parent As MoviesViewModel)
			AllowNew = True

			parent = parent

			Dim rating As Rating

			rating = New Rating(Me)
			rating.Value = 1
			rating.Name = "1 Star"

			Add(rating)

			rating = New Rating(Me)
			rating.Value = 2
			rating.Name = "2 Stars"

			Add(rating)

			rating = New Rating(Me)
			rating.Value = 3
			rating.Name = "3 Stars"

			Add(rating)

			rating = New Rating(Me)
			rating.Value = 4
			rating.Name = "4 Stars"

			Add(rating)

			rating = New Rating(Me)
			rating.Value = 5
			rating.Name = "5 Stars"

			Add(rating)
		End Sub

#End Region

#Region "Properties"

		Public Property Parent() As MoviesViewModel
			Get
				Return _parent
			End Get
			Set(value As MoviesViewModel)
				_parent = value
			End Set
		End Property

#End Region

#Region "BindingList Overrides"

		Protected Overrides Function AddNewCore() As Object
			Dim rating As Rating = DirectCast(MyBase.AddNewCore(), Rating)
			rating.Parent = Me
			Return rating
		End Function

#End Region

	End Class

	Public Class Rating
		Inherits ObservableObject

#Region "Fields"

		Protected _parent As Ratings
		Protected _value As Integer
		Protected _name As String

#End Region

#Region "Constructors"

		Public Sub New()
			'Value = 0;
			'Name = string.Empty;
		End Sub

		Public Sub New(parent As Ratings)
			Me.New()
			parent = parent
		End Sub

#End Region

#Region "Data Properties"

		Public Property Parent() As Ratings
			Get
				Return _parent
			End Get
			Set(value As Ratings)
				_parent = value
			End Set
		End Property

		Public Property Value() As Integer
			Get
				Return _value
			End Get
			Set(value As Integer)
				_value = value
				MyBase.RaisePropertyChangedEvent("Value")
			End Set
		End Property

		Public Property Name() As String
			Get
				Return _name
			End Get
			Set(value As String)
				_name = value
				MyBase.RaisePropertyChangedEvent("Name")
			End Set
		End Property

#End Region

#Region "ToString Overrides"

		Public Overrides Function ToString() As String
			Return Name
		End Function

#End Region

	End Class

End Namespace